
const St = imports.gi.St;
const Main = imports.ui.main;
const Tweener = imports.ui.tweener;

let text, button;	//系统示例用
let lg;			//lookingGlass对象
let lgBtn;		//顶部中间的按钮

/*
	扩展创建工具自动生成的例子
 */
function _hideHello() {
	Main.uiGroup.remove_actor(text);
	text = null;
}

/*
	扩展创建工具自动生成的例子
 */
function _showHello() {
	if (!text) {
		text = new St.Label({ style_class: 'helloworld-label', text: "Hello, world!"});
		Main.uiGroup.add_actor(text);
	}

	text.opacity = 255;

	let monitor = Main.layoutManager.primaryMonitor;

	text.set_position(Math.floor(monitor.width / 2 - text.width / 2),
			Math.floor(monitor.height / 2 - text.height / 2));

	Tweener.addTween(text,
			{ opacity: 0,
			  time: 2,
			  transition: 'easeOutQuad',
			  onComplete: _hideHello
			 });
	//global.get_window_actors().forEach(function(w){w.set_scale(0.5,0.5)});
}

/*
 * 切换lookingGlass窗口的状态，如当前关闭则打开，反之则关闭
 */
function _toggleLookingGlass(actor, event) {
	//检测按键对应码用
	//lgBtn.label = event.type().toString()+ " key_code:" + event.get_key_code().toString()+ " key_symbol:" + event.get_key_symbol().toString();
	if(event.type() == 2 && event.get_key_code() == 96) {
		lg.toggle();
		return true;
	}
	return false;
}

/*
 * 当焦点在lookingGlass按钮时的事件，如当前关闭则打开，反之则关闭
 * 可能有更好的处理方法，对事件还不熟
 */
function _press_toggleLookingGlass(actor, event) {
	if(event.type() == 6) {
		lg.toggle();
		return true;
	}
	return false;
}

/*
 * 打开lookingGlass窗口
 */
function _openLookingGlass(actor, event) {
	let type = event.type();
	let code = event.get_key_code();
	if((type == 2) && (code == 65 || code == 96)) {
		lg.open();
		return true;
	}
	else if((type == 1) && (code == 116)) {
		lg.open();
		return true;
	}
	return false;
}

function _test(actor, event) {
	lgBtn.label = "clicked";
}

function init() {
	/*以下为系统示例代码*/
	button = new St.Bin({ style_class: 'panel-button',
			reactive: true,
			can_focus: true,
			x_fill: true,
			y_fill: false,
			track_hover: true });
	let icon = new St.Icon({ icon_name: 'system-run',
			icon_type: St.IconType.SYMBOLIC,
			style_class: 'system-status-icon' });

	button.set_child(icon);
	button.connect('button-press-event', _showHello);
	/*以上为系统示例代码*/

	/*
	 * 创建显示在顶部中间的按钮
	 */
	//用style_class保持样式统一，其中panel-button在/usr/share/gnome-shell/theme/gnome-shell.css中查到
	lgBtn = new St.Button({style_class:"panel-button",label:"lookingGlass",reactive:true,can_focus:true,track_hover:true});
	lgBtn.connect_after('captured-event', _openLookingGlass);
	lgBtn.connect('button-press-event', _press_toggleLookingGlass);

	//在活动界面添加F12快捷键
	global.stage.connect('captured-event', _toggleLookingGlass);
}

/*
 * 启用插件时执行的代码，插入控件
 */
function enable() {
	Main.panel._rightBox.insert_child_at_index(button, 0);
	Main.panel._centerBox.add_actor(lgBtn);
	/*
 	 * 检测系统是否包含lookingGlass对象，不存在则创建一个
 	 */
	if (Main.lookingGlass == null) {
        	Main.lookingGlass = new Main.LookingGlass.LookingGlass();
    	}
	lg = Main.lookingGlass;
	/*
	 * 对lookingGlass的控制启用快捷键
	 */
	lg.actor.connect('captured-event', _toggleLookingGlass);
}

/*
 * 停用插件时执行的代码，移除控件
 */
function disable() {
	Main.panel._rightBox.remove_child(button);
	Main.panel._centerBox.remove_actor(lgBtn);
}
